// "Dynamisk HTML"-skript av David Grundberg. (c) 2002.


currentMenu="";
menuTimer = null;
hasMenuTimer = 0;

// Detta skapar getElementById fr Internet Explorer 4.
if (!document.getElementById && document.all) {
	document.getElementById = new Function('id', 'return document.all[id]')
}

function dhide(id) {
	var kylare = document.getElementById(id);
	kylare.style.visibility = "hidden";
}

function dshow(id) {
	var kylare = document.getElementById(id);
	kylare.style.visibility = "visible";
}

function dtoggleVisibility(id) {
	var kylare = document.getElementById(id);
	if (kylare.style.visibility == "visible") {
		kylare.style.visibility = "hidden";
	}
	else {
		kylare.style.visibility = "visible";
	}
}

function dclose(id) {
	var kylare = document.getElementById(id);
	kylare.style.display = "none";
}

function dopen(id) {
	var kylare = document.getElementById(id);
	kylare.style.display = "block";
}

function dtoggleOpen(id) {
	var kylare = document.getElementById(id);
	if (kylare.style.display == "none") {
		kylare.style.display = "block";
	}
	else {
		kylare.style.display = "none";
	}
}

function dopenMenu(id) {
// GLOBAL: currentMenu;
	
	if (currentMenu != id) {
		if (currentMenu != "") {
			_menuHide(currentMenu);
		}
		currentMenu=id;
		_menuShow(id);
	}
	denterMenu(id);
}

function dleaveMenu(id) {
// GLOBAL: hasMenuTimer, menuTimer, currentMenu
	if (currentMenu == id) {
		menuTimer=window.setTimeout("_menuEvent();",200);
		hasMenuTimer=1;
	}
}

function denterMenu(id) {
// GLOBAL: hasMenuTimer, menuTimer, currentMenu
	if (currentMenu == id) {

	if (hasMenuTimer) {
		window.clearTimeout(menuTimer);
		hasMenuTimer=0;
	}
	}
}

function _menuEvent() {
// GLOBAL: currentMenu, hasMenuTimer
		_menuHide(currentMenu);
		currentMenu="";
		hasMenuTimer=0;
}

function _menuShow(id) {
	var kylare = document.getElementById(id);
//	kylare.style.visibility = "visible";
//	kylare.style.zindex = 100; // Snygghet, enkelhet, 0-1.
	kylare.style.display = "block";

}
function _menuHide(id) {
	var kylare = document.getElementById(id);
//	kylare.style.visibility = "hidden";
//	kylare.style.zindex = 1;
	kylare.style.display = "none";

}

fuling = null;
moveArray = new Array();

function dmoveAcc(id, x, y, v0,v1, onDone) {
	var kylare = document.getElementById(id);
	

	var sx, sy;
	sx=parseInt(kylare.style.left); // Frsta gngen, innan style.left r satt i javascript, blir sx och sy NaN.	I gecko och ie5.0 i alla fall.
	sy=parseInt(kylare.style.top);
	if (isNaN(sx) || isNaN(sy)) {
		sx=0;
		sy=0;
		alert('NaN');
	}

	firstnull=-1;
	index=-1;
	for (var i in moveArray) {
		if ((moveArray[i] == null) && (firstnull != -1)) {
			firstnull=i;
		}
		if (moveArray[i].element == kylare) {
			index=i;
			break;
		}
	}
	
	if (index == -1) {
		index=firstnull;
		if (firstnull == -1) {
			index=moveArray.length;
		}
	}
	
/*	hej=document.getElementById('status');
	hej.innerHTML="hej"+moveArray.length;*/
	moveArray[index] = new TMoveObject(kylare,sx,sy,x,y,v0,v1,onDone);
	moveArray[index].interval=16;
	window.setTimeout("_moveTimer("+index+");",moveArray[index].interval);
}

function TMoveObject(element,startx,starty,endx,endy,speed0,speed1,onDone) {
	this.element = element;
	this.startx = startx;
	this.starty = starty;
	this.onDone = onDone;
	this.endx = endx;
	this.endy = endy;
	this.x = startx;
	this.y = starty;	
	this.v0 = Math.abs(speed0);
	this.v1 = Math.abs(speed1);
	this.radiant=Math.atan((this.endx-this.startx)/(this.endy-this.starty));
	if (this.endy-this.starty < 0) {
		this.radiant+=Math.PI;   // Vrid vinkeln 180 grader.
	}
	this.s=Math.sqrt(Math.pow(this.endx-this.startx,2)+Math.pow(this.endy-this.starty,2));
//	this.s=this.endx-this.startx;
	this.interval=40; // interval 40 == 25 "fps"; interval 16 == 60 "fps"
	if (this.s < 0) {
		this.v0=-this.v0;
		this.v1=-this.v1;
		alert('hej');
	}
	
	/*
	Nert:   0
	Hger:   90
	uppt:  180
	vnster:270*/
	
	this.t=(this.s*2)/(this.v0+this.v1);
	this.a=(this.v1-this.v0)/this.t;
	this.v1=this.v0+this.a*this.t;
	this.ht=0;
	d=new Date();
	this.startTime=d.getTime();
	this.timer = null;
	this.calculate=TMoveObjectCalculate;
	this.finished=0;
/*	alert('s'+this.s+'t'+this.t+'a'+this.a);
	alert('v1'+this.v1);*/
}

function TMoveObjectCalculate() {
	d=new Date();
	this.ht+=(d.getTime()-this.startTime)/1000;
	
	s=this.v0*this.ht+this.a*this.ht*this.ht/2;
	
	this.x=this.startx+s*Math.sin(this.radiant); //cos
	this.y=this.starty+s*Math.cos(this.radiant); //sin
	if (this.ht > this.t) {
		this.finished=1;
	}
}

function _moveTimer(index) {
	moveArray[index].calculate();
	if (!moveArray[index].finished) {
		moveArray[index].element.style.left=moveArray[index].x+'px';
		moveArray[index].element.style.top=moveArray[index].y+'px';
		window.setTimeout("_moveTimer("+index+");",moveArray[index].interval);
	}
	else {
		moveArray[index].element.style.left=moveArray[index].endx+'px';
		moveArray[index].element.style.top=moveArray[index].endy+'px';
		eval(moveArray[index].onDone);
//		moveArray[index]=null; // ta bort objekt. (funkiert nicht)
	}

}


function dsetPosition(id, x, y) {
	var kylare = document.getElementById(id);
	// varfr heter variabeln som pekar mot ett *element* *kylare* fr? Ja, sug p den! :)
	kylare.style.left=x+"px";
	kylare.style.top=y+"px";

}